/* BeaSTM Add-On (c) Thorbjörn Jemander */

#pragma export on
extern "C" 
{
bool Process( uint16 *argSourceData, uint16 *argDestinationData, uint32 XSize, uint32 YSize );
}
#pragma export reset

float	CalcSumPowerData( uint32 argRowNumber, uint16 *argData, uint32 argXSize, uint32 argPower );
void	CopySubtractedLine( uint32 argRow, uint16 *argDestData, uint16 *argSourceData, uint32 argXSize, float m, float k, float l );

bool
Process( uint16 *argSourceData, uint16 *argDestinationData, uint32 argXSize, uint32 argYSize )
{
	printf("XSize: %d, YSize: %d\n", argXSize, argYSize );

	float	m,
			k,
			l,
			N = argYSize,
			n = N - 1,
			A = n*n*n*n*n/5 + n*n*n*n/2 + n*n*n/3 - n/30,
			B = n*n*(n+1)*(n+1)/4,
			C = n*n*n/3 + n*n/2 + n/6,
			D = n*(n+1)/2,
			E = n + 1,
			F,
			G,
			H;

	uint32	row;
			
	for( row = 0; row < argYSize; row++ )
	{
		F = CalcSumPowerData( row, argSourceData, argXSize, 2 );
		G = CalcSumPowerData( row, argSourceData, argXSize, 1 );
		H = CalcSumPowerData( row, argSourceData, argXSize, 0 );

		m = ( (C*A-B*B)*(H*A-C*F)-(D*A-B*C)*(G*A-B*F) ) / ( (C*A-B*B)*(E*A-C*C)-(D*A-B*C)*(D*A-B*C) );
		k = (G*A-B*F-(D*A-B*C)*m) / (C*A - B*B );
		l = (F-B*k-C*m)/A;
		
		CopySubtractedLine( row, argDestinationData, argSourceData, argXSize, m, k, l );
	}

	return true;
}

float
CalcSumPowerData( uint32 argRowNumber, uint16 *argData, uint32 argXSize, uint32 argPower )
{
	float 	i;
	float	Sum = 0;
	
	switch( argPower )
	{
		case 0:
			for( i=0; i<argXSize; i++ )
				Sum += argData[ argRowNumber * argXSize + (uint32)i ];
		break;
		case 1:
			for( i=0; i<argXSize; i++ )
				Sum += i*argData[ argRowNumber * argXSize + (uint32)i ];
		break;
		case 2:
			for( i=0; i<argXSize; i++ )
				Sum += i*i*argData[ argRowNumber * argXSize + (uint32)i ];
		break;
		default:
			for( i=0; i<argXSize; i++ )
				Sum += pow(i,argPower)*argData[ argRowNumber * argXSize + (uint32)i ];
	}
	
	return Sum;
}

void
CopySubtractedLine( uint32 argRow, uint16 *argDestData, uint16 *argSourceData, uint32 argXSize, float m, float k, float l )
{
	uint32 	i;
	
	for( i=0; i<argXSize; i++ )
		argDestData[ argRow * argXSize + i ] = 
			argSourceData[ argRow * argXSize + i ] - ( i*k + i*i*l );
}
